clc

%% NET 

port = uint32(2000);
target = '10.0.0.51';

%% FIR 
% number of coeficients
nc = uint32(512);
% number of input points
nt = uint32(8);
% number of output points
nf = uint32(25);

% coef
c_net = int16(fir_net_init(nc, nf, nt));

% data
data = int16(round((16384).*randn(nt,(nc*8))));

%% SW
tic
y_sw = fir_net(data, c_net, nf, nt);
toc
%% HW
% Reset FIR net
tic
sendrst(target, port);
% Send coeficients
sendcoef(target, port, nf, nt, c_net);
tic
y_hw = sendudp(target, port, nf, nt, data);
toc

%% COMAPRE
% y_sw==y_hw
compare = min(min(y_sw==y_hw))
