// mex -O sendudp.c C:\pf\MATLAB\R2007a\sys\lcc\lib\wsock32.lib -DWIN32
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <winsock.h>

#include "mex.h"

#define SIZE 1272
//#define NUM_FIR 25
#define DATAWIDTH 16
//#define NUM_TRIANGLE 8

void usage(char *pgm){

	mexPrintf("%s <Dst. IP> <Dst. port> [Src IP] <input file> <output file>\n", pgm);
	exit(0);
}




//int main(int argc, char **argv)
//sendudp('10.0.0.51', uint32(port) , numfir, numtriangle,  coefarray);
void mexFunction(
    int           nlhs,           /* number of expected outputs */
    mxArray       *plhs[],        /* array of pointers to output arguments */
    int           nrhs,           /* number of inputs */
    const mxArray *prhs[]         /* array of pointers to input arguments */
    ) 

{
	WSADATA w;								/* Used to open Windows connection */
	unsigned short port_number;				/* The port number to use */
	SOCKET sd;								/* The socket descriptor */
	int server_length;						/* Length of server struct */
	short send_buffer[SIZE/2];		/* Data to send */
	char recv_buffer[SIZE];		/* Received data */
	struct hostent *hp;						/* Information about the server */
	struct hostent *he;						/* Information about the client */
	struct sockaddr_in server;				/* Information about the server */
	struct sockaddr_in client;				/* Information about the client */
//	int a1, a2, a3, a4;						/* Server address components in xxx.xxx.xxx.xxx form */
//	int b1, b2, b3, b4;						/* Client address components in xxx.xxx.xxx.xxx form */
	char host_name[256];					/* Host name of this computer */
	char server_name[256];					/* Host name of this computer */
    struct in_addr addr;                    /* Address of this computer */

	//FILE *fp_in, *fp_out;
	int i, j, k, len;
	long lSize;
	//size_t result;

      time_t start;                /* Time measuring */
      time_t stop;

  //    int counter;
  
	int mrows, ncols;
    short *xValues;
    int *yValues;
    
    unsigned short *portnum;
    unsigned short *numfir;
    unsigned short *numtriangle;

	int onewrite;
	int resultlen;
	int num_sym;
	int sumlen;
    
    

//    mexPrintf("Num of imputs : %d\n",nrhs);
//    mexPrintf("Num of expected outputs : %d\n", nlhs);
    
    mxGetString(prhs[0],server_name,255);
//    mexPrintf("IP : '%s'\n", server_name);
    

    portnum = mxGetPr(prhs[1]);
//    mexPrintf("Port : %d\n", *portnum);
    
    port_number=*portnum;

    numfir = mxGetPr(prhs[2]);
//    mexPrintf("NUM_FIR : %d\n", *numfir);

    numtriangle = mxGetPr(prhs[3]);
//    mexPrintf("NUM_TRIANGLE : %d\n", *numtriangle);
    
        
    
	/* Open windows connection */
	if (WSAStartup(0x0101, &w) != 0)
	{
		mexErrMsgTxt("Could not open Windows connection.\n");
		exit(0);
	}

	/* Open a datagram socket */
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if (sd == INVALID_SOCKET)
	{
		mexErrMsgTxt("Could not create socket.\n");
		WSACleanup();
		exit(0);
	}

	/* Clear out server struct */
	memset((void *)&server, '\0', sizeof(struct sockaddr_in));

	/* Set family and port */
	server.sin_family = AF_INET;
	server.sin_port = htons(port_number);
    
    /* Try IP address */
    addr.s_addr=inet_addr(server_name);
    if (addr.s_addr==INADDR_NONE){
        /*Can't resolve host string as dot notation IP number...
    	  try lookup IP from hostname */
        //	fprintf(stderr,"Trying nameserverlookup:%s\n",hostname);
        he=gethostbyname(server_name);
    	if(he==NULL){
            mexPrintf("\nUNKNOWN HOST:%s\n",server_name);
    	    exit(0);  /* Can not lookup hostname */
    	}
            addr = *((struct in_addr *)he->h_addr);
    }    

	/* Set server address */
    server.sin_addr=addr;

    /* Clear out client struct */
	memset((void *)&client, '\0', sizeof(struct sockaddr_in));

	/* Set family and port */
	client.sin_family = AF_INET;
	client.sin_port = htons(0);

		/* Get host name of this computer */
		gethostname(host_name, sizeof(host_name));
		hp = gethostbyname(host_name);

		/* Check for NULL pointer */
		if (hp == NULL)
		{
			mexErrMsgTxt("Could not get host name.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}

		/* Assign the address */
		client.sin_addr.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
		client.sin_addr.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
		client.sin_addr.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
		client.sin_addr.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];

	/* Bind local address to socket */
	if (bind(sd, (struct sockaddr *)&client, sizeof(struct sockaddr_in)) == -1)
	{
		mexErrMsgTxt("Cannot bind address to socket.\n");
		closesocket(sd);
		WSACleanup();
		exit(0);
	}

	mrows = mxGetM(prhs[4]);
	ncols = mxGetN(prhs[4]);
	xValues = mxGetPr(prhs[4]);
/*
  if(mrows*ncols*2+2>SIZE){
		mexErrMsgTxt("So much of data.\n");
		closesocket(sd);
		WSACleanup();
		exit(0);
  
  }
*/

	for(j=0; j<mrows; j++){
//     mexPrintf("FIR : %d , TRIANGLE : %d\n", j%(*numfir), j/(*numfir));
	  send_buffer[0]=256+(j/(*numfir));//coef tag + T_ID
	  send_buffer[1]=(j%(*numfir))*256;//FIR_ID + debug=0
	  for(i=0; i<ncols; i++){
      send_buffer[(i+2)]=xValues[j+(i*mrows)];
//       mexPrintf("%d ", xValues[j+(i*mrows)]);
    }
//      mexPrintf("\n");
    
 		/* Tranmsit data */

		server_length = sizeof(struct sockaddr_in);
		if (sendto(sd, send_buffer, (int)ncols*sizeof(short)+4, 0, (struct sockaddr *)&server, server_length) == -1)
		{
			mexErrMsgTxt("Error transmitting data.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
		
    /* Receive data */
    
		len = recvfrom(sd, recv_buffer, SIZE, 0, (struct sockaddr *)&server, &server_length);
		if (len < 0)
		{
			mexErrMsgTxt("Error receiving data.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}
    
  }





	closesocket(sd);
	WSACleanup();


}

